QGIS Application - Bug report #14041
opening the layer properties window can take ages nowadays
2015-12-29 01:40 AM - Mathieu Pellerin - nIRV

Status: Closed

Priority: Severe/Regression

Assignee:

Category: Vectors

Affected QGIS version:master Regression?: No

Operating System: Easy fix?: No

Pull Request or Patch supplied: Resolution: fixed/implemented
Crashes QGIS or corrupls data: Copied to github as #: 22053
Description

I've noticed that for some time now, opening the layer properties window can take 4-5 seconds on layers having a large number of fields.
Steps to reproduce

1. Create a new project

2. Add the attached vector shapefile dataset (it's a single polygon, with a large number of fields)

3. Double click on the layer to open its properties window

4. You'll notice it will take quite a long time, during which QGIS is frozen

You can also see a freeze / slowdown when you open the fields dropdown list in the labelling panel of the properties window.

Anybody else has noticed this regression?

Associated revisions

Revision 34c9daab - 2015-12-30 11:35 AM - Nyall Dawson

Fix slow icon rendering in field combo box (refs #14041)

Revision fc086adb - 2016-01-23 08:40 PM - Martin Dobias

Remove too much debug output when loading attribute table (refs #14041)

This makes debug version much faster, probably not much difference in release version

History

#1 - 2015-12-29 02:41 AM - Nyall Dawson

It's not just you - I'm seeing this too.

#2 - 2015-12-29 05:00 PM - Mathieu Pellerin - nIRV
- Category changed from GUI to Vectors
- Priority changed from Normal to Severe/Regression

Ok, good to know it isn't just me.

Elevating to blocker since it's an ongoing regression that affects basic operations.
#3 - 2015-12-30 06:00 PM - Mathieu Pellerin - nIRV

Nyall, after your commit:34c9daa, | cannot see a difference in speed between opening a layer properties window for a dataset containing dozens of fields
vs. a dataset containing 2-3 fields. So that's a huge win.

That said, | feel opening the window still takes a noticeable amount of time. Maybe it has been like that for a while though, and the field-linked regression is

fixed. Should we close this and mark it as fixed?

#4 - 2016-01-23 11:49 AM - Martin Dobias

Mathieu, if you use Debug version of QGIS, then my latest commit may speed up loading significantly (tested with 100K rows - before ~13s, after ~2s).

Shall we close this issue or do you have other examples where opening attribute table takes much longer that it should? (especially compared to previous

releases)

#5 - 2016-01-23 11:49 AM - Martin Dobias

- Status changed from Open to Feedback

#6 - 2016-01-24 10:46 PM - Mathieu Pellerin - nIRV

Martin, the regression | had spotted was when opening the layer properties window, not the attribute table. Nyall wanted this issue to stay open until he felt

confident he had done everything he could to speed up that properties window, will leave it to him to close this issue.

#7 - 2016-01-24 11:59 PM - Nyall Dawson
- Status changed from Feedback to Closed

I think we've done all we can - | tried profiling this, but the main delay now is all in Qt's widget layout/creation code.

#8 - 2016-01-25 12:07 AM - Mathieu Pellerin - nIRV

- Resolution set to fixed/implemented

Nyall, ok. As | mentioned on github, your commits had already brought the situation back to "normal", i.e. the usual delay | see with say opening the
Settings window. Thanks for fixing this.

#9 - 2016-01-25 01:05 AM - Martin Dobias

(facepalm) sorry guys, | have terribly misread the report :)

Files

slow.zip 11.9 KB 2015-12-29 Mathieu Pellerin - nIRV
